﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace NestedPropertiesPropertGrid
{
    class Order: INotifyPropertyChanged
    {
        public string ShipAddress { get; set; }
        public string ShipCountry { get; set; }
        public string ShipName { get; set; }
        public string ShipPostalCode { get; set; }

        public string FirstName 
        {
            get { return this.Employee.FirstName; }
            set 
            {
                if (this.Employee.FirstName != value)
                {
                    this.Employee.FirstName = value;
                    this.OnPropertyChanged("Employee");
                }
            }
        }

        public Employee Employee { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
